#!/bin/sh

file_name=`basename $0`
proclist=`pgrep $file_name`
count=`echo $proclist | tr ' ' '\n' | wc -l` 
if [ $count != 1 ] ; then 
    echo "Warning! Another process was started already [$count]"
    exit 0
fi

for i in $* ; do
    key=`echo $i | sed -e 's/--\(.*\)=\(.*\)/\1/'`
    value=`echo $i | sed -e 's/--\(.*\)=\(.*\)/\2/'`
    if [ "$key" = "src" ] ; then
        src=$value
    elif [ "$key" = "dst" ] ; then
        dst=$value
    fi
done
[ -f $src ] || exit 0
cp -f $src $src.tmp
mv -f $src.tmp $dst/`basename $src`


