#!/usr/bin/python3

import os, sys
import pymysql
import optparse
import re

def getWorkingTables(views):
    tables = []
    try:
        conn = pymysql.connect(host = 'localhost', user = 'netroot', passwd = 'netroot', db = "dictionaries")
        cursor = conn.cursor()

        if not views:
            cursor.execute("show full tables FROM dictionaries where Table_type = 'VIEW'")
            rows = cursor.fetchall()
            for row in rows:
                views.append(row[0])
        for view in views:
            cursor.execute("show create view `%s`" % (view))
            row = cursor.fetchone()
            matches = re.findall('%s[12]' % (view), row[1])
            if matches:
                tables.append(matches[0])
    except Exception as e:
        print(e)
        pass

    if conn:
        conn.close()
    return tables

def dictionariesDump(resultFile, views = []):
    print('Создание дампа справочников')

    tables = getWorkingTables(views)
    if tables:
        with open(resultFile, 'w') as outfile:
            outfile.write('SET NAMES utf8;\n')
        os.system("mysqldump -u root -c --compact --no-create-info --skip-triggers --skip-add-locks --skip-comments dictionaries %s >> %s" % (" ".join(tables), resultFile))
        os.system("sed -i 's/^INSERT INTO `\([^0-9]\+\)[1-2]`/DELETE FROM `\\1`;\\nINSERT INTO `\\1`/' %s" % resultFile)
        print("Дамп сохранен в %s" % resultFile)

if __name__ == '__main__':
    parser = optparse.OptionParser(description = "Используется для создания дампа справочников.")
    parser.add_option("-d", "--dictionariesDump", action="store_true", dest="dictionariesDump", help="Создать дамп базы dictionaries для всех представлений (view)")
    parser.add_option("-l", "--liteDump", action="store_true", dest="liteDump", help="Создать дамп базы dictionaries для основных представлений (view)")
    parser.add_option("-v", "--viewsDump", dest="viewsDump", metavar="\"tmc, valut\"", help="Создать дамп базы dictionaries для указанных представлений (view)")
    parser.add_option("-f", "--filename", dest="filename", metavar="dictionaries.sql", help="Путь до файла, куда будет сохранен дамп")
    (options, args) = parser.parse_args(sys.argv[1:])

    resultFile = 'dictionaries.sql'
    if options.filename:
        resultFile = options.filename

    if options.dictionariesDump:
        dictionariesDump(resultFile)
    elif options.viewsDump:
        views = [item.strip() for item in options.viewsDump.split(',')]
        dictionariesDump(resultFile, views)
    elif options.liteDump:
        views = ['actionparameter', 'cardgroup', 'cmaction', 'cmevent', 'command', 'kbkey', 'macro', 'macroparameters', 'menu', 'menuitem', 'mol', 'role', 'rolecommand', 'rolerelation', 'roleuser', 'units', 'valut']
        dictionariesDump(resultFile, views)
